import jp.ac.takushoku_u.cs.*;

/**
* LFTAnalysisNX̃eXgpNX
* @version 1.3
* @author } Tj(Kasajima Hiroshi)
*/
/*
* ŏIXV 2005N0108
*/
class LFTAnalysisTest{

public static void main(String[] args){

	boolean[][] sampleData = { //҂̃}gNXf[^
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
		boolean[][] sampleData2 = { //wK҂̃}gNXf[^ ҂ɔ(7,6)Ȃ
		    {false,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{true,false,false,false,false,false,false,false,false},
			{false,true,true,true,false,false,false,false,false},
			{false,false,false,false,true,false,false,false,false},
			{false,false,false,false,false,false,false,false,false},
			{false,false,false,false,false,true,false,false,false},
			{false,false,false,false,false,true,true,true,false}};
	
	String[] name = {"vf1","vf2","vf3","vf4","vf5","vf6","vf7","vf8","vf9"};
	
	//}gNX̐
	BooleanMatrix dataMatrix = new BooleanMatrix(sampleData, name, name);
	BooleanMatrix dataMatrix2 = new BooleanMatrix(sampleData2, name, name);
	
	//LFT͂s
	LFTAnalysis result = new LFTAnalysis(dataMatrix, dataMatrix2);
	
	//҂̃}gNXo͂
	BooleanMatrix outTeacherMatrix = new BooleanMatrix(5,5);
	//҂̃}gNX̎
	outTeacherMatrix.matrixCopy(result.getTeacherMatrix());
	System.out.println("҂̃}gNX");
	//}gNX̏o
	outputMatrix(outTeacherMatrix);
	
	//҂̃}gNXƊwK҂̃}gNX1ɂo͂
	StringMatrix outBlendStringMatrix = new StringMatrix(9,9);
	outBlendStringMatrix.matrixCopy(result.getBlendStringMatrix());
	System.out.println("҂̃}gNXƊwK҂̃}gNXꏏɕ\}gNX");
	System.out.println("҂Ȃ = 0, ҂ = 1, ҂̂ = T, wK҂̂ = S");
	outputMatrix(outBlendStringMatrix);
	
	//҂̃}gNXɂ}̏dvxo͂
	ArithmeticMatrix outEdgeMatrix = new ArithmeticMatrix(9,9);
	outEdgeMatrix.matrixCopy(result.getEdgeTeacherMatrix());
	System.out.println("҂̎}̏dvx\}gNX");
	outputDoubleMatrix(outEdgeMatrix);
	
	//҂̉B}gNXo͂
	BooleanMatrix outReachMatrix = new BooleanMatrix(9,9);
	outReachMatrix.matrixCopy(result.getReachTeacherMatrix());
	System.out.println("҂̉B}gNX");
	outputMatrix(outReachMatrix);
	
	//҃}gNX(6,5)̗vfΏWo͂
	BooleanMatrix outPairMatrix = new BooleanMatrix(9,9);
	outPairMatrix.matrixCopy(result.getElementPairMatrix(dataMatrix, 
		dataMatrix.getRowNumber("vf6"), dataMatrix.getColNumber("vf5")));
	System.out.println("҂̃}gNXɂāA}(6,5)̗vfΏW}gNX");
	outputMatrix(outPairMatrix);
	
	System.out.println("vf΂̗vf = " + outPairMatrix.getElement());
	System.out.println();
	
	//vZŋ߂ꂽl
	System.out.println("ގx= " + result.getResemble());
	System.out.println("Bx= " + result.getAttainment());
	System.out.println("҂̎}= " + result.getTeacherEdge());
	System.out.println("wK҂̎}= " + result.getStudentEdge());
	System.out.println("v}= " + result.getAccordEdge());
	System.out.println("ɂł}= " + result.getTotelEdge());
	System.out.println("wK҂݂̂̎}= " + result.getStudentOnlyEdge());
	System.out.println("҂݂̂̎}= " + result.getTeacherOnlyEdge());
}
	
/**
* }gNXint^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputMatrix(ArithmeticMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+(int)outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+(int)outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
	
/**
* }gNXdouble^ŕWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputDoubleMatrix(ArithmeticMatrix outMatrix){
		java.text.NumberFormat df = new java.text.DecimalFormat("0.000");		//_ȉ3܂ŏo
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){
			System.out.print(outMatrix.getColName(j) + " ");		//񖼏o
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			System.out.print(outMatrix.getRowName(i) + "  ");		//so
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(df.format(outMatrix.getCell(i, j)));
				}
				else{
					System.out.print(df.format(outMatrix.getCell(i, j) )+" ");
				}
			}
		}
		System.out.println();
	}
	
/**
* }gNXboolean^ŕWo͂ɏo͂܂B
*/
	private static void outputMatrix(BooleanMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println(" "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print(" "+outMatrix.getCell(i, j));
					if(outMatrix.getCell(i, j)){
						System.out.print(" ");
					}
				}
			}
		}
		System.out.println();
	}
	
/**
* StringMatrixWo͂ɏo͂܂B
* @param outMatrix oׂ͂}gNX
*/
	private static void outputMatrix(StringMatrix outMatrix){
		System.out.print("       ");
		for(int j = 0; j < outMatrix.getColLength(); j++){		//񖼏o
			System.out.print(outMatrix.getColName(j) + " ");
		}
		System.out.println();
		for(int i = 0 ; i < outMatrix.getRowLength(); i++){
			if(i < 9){
			System.out.print(outMatrix.getRowName(i) + " ");		//so
			}
			else{
				System.out.print(outMatrix.getRowName(i) + " ");
			}
			for(int j = 0; j < outMatrix.getColLength(); j++){		//vfo
				if(j == (outMatrix.getColLength() - 1)){
					System.out.println("     "+outMatrix.getCell(i, j));
				}
				else{
					System.out.print("     "+outMatrix.getCell(i, j));
				}
			}
		}
		System.out.println();
	}
}
